using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using MyBankSoftware;

namespace GUI_BankClient
{
	/// <summary>
	/// Zusammenfassung fr FormBankClient.
	/// </summary>
	public class FormBankClient : System.Windows.Forms.Form
	{
		enum enumBankOperation 
		{
			CreateAccount = 1, DeleteAccount, PayIn, PayOut
		}

		private System.Windows.Forms.TextBox txtAccountNum;
		private System.Windows.Forms.Button btnCreateAccount;
		private System.Windows.Forms.Label lblAccountNum;
		private System.Windows.Forms.Button btnDeleteAccount;
		private System.Windows.Forms.TextBox txtAmount;
		private System.Windows.Forms.Label lblAmount;
		private System.Windows.Forms.Button btnPayIn;
		private System.Windows.Forms.Button btnPayOut;
		private System.Windows.Forms.Label lblAccountBalance;
		private System.Windows.Forms.TextBox txtBalance;
		private System.Windows.Forms.Button btnCheckBalance;
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox txtMessages;
		private System.Windows.Forms.Label label1;

		private BankServer objBank;

		public FormBankClient()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

			//
			// TODO: Fgen Sie den Konstruktorcode nach dem Aufruf von InitializeComponent hinzu
			//

			objBank = new BankServer();

		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtAccountNum = new System.Windows.Forms.TextBox();
			this.btnCreateAccount = new System.Windows.Forms.Button();
			this.lblAccountNum = new System.Windows.Forms.Label();
			this.btnDeleteAccount = new System.Windows.Forms.Button();
			this.txtAmount = new System.Windows.Forms.TextBox();
			this.lblAmount = new System.Windows.Forms.Label();
			this.btnPayIn = new System.Windows.Forms.Button();
			this.btnPayOut = new System.Windows.Forms.Button();
			this.lblAccountBalance = new System.Windows.Forms.Label();
			this.txtBalance = new System.Windows.Forms.TextBox();
			this.btnCheckBalance = new System.Windows.Forms.Button();
			this.txtMessages = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// txtAccountNum
			// 
			this.txtAccountNum.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtAccountNum.Location = new System.Drawing.Point(96, 8);
			this.txtAccountNum.Name = "txtAccountNum";
			this.txtAccountNum.Size = new System.Drawing.Size(96, 22);
			this.txtAccountNum.TabIndex = 0;
			this.txtAccountNum.Text = "";
			// 
			// btnCreateAccount
			// 
			this.btnCreateAccount.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnCreateAccount.Location = new System.Drawing.Point(8, 40);
			this.btnCreateAccount.Name = "btnCreateAccount";
			this.btnCreateAccount.Size = new System.Drawing.Size(120, 24);
			this.btnCreateAccount.TabIndex = 1;
			this.btnCreateAccount.Text = "Create Account";
			this.btnCreateAccount.Click += new System.EventHandler(this.btnCreateAccount_Click);
			// 
			// lblAccountNum
			// 
			this.lblAccountNum.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblAccountNum.Location = new System.Drawing.Point(8, 11);
			this.lblAccountNum.Name = "lblAccountNum";
			this.lblAccountNum.Size = new System.Drawing.Size(100, 24);
			this.lblAccountNum.TabIndex = 2;
			this.lblAccountNum.Text = "AccountNum:";
			// 
			// btnDeleteAccount
			// 
			this.btnDeleteAccount.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnDeleteAccount.Location = new System.Drawing.Point(136, 40);
			this.btnDeleteAccount.Name = "btnDeleteAccount";
			this.btnDeleteAccount.Size = new System.Drawing.Size(120, 24);
			this.btnDeleteAccount.TabIndex = 1;
			this.btnDeleteAccount.Text = "Delete Account";
			this.btnDeleteAccount.Click += new System.EventHandler(this.btnDeleteAccount_Click);
			// 
			// txtAmount
			// 
			this.txtAmount.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtAmount.Location = new System.Drawing.Point(96, 88);
			this.txtAmount.Name = "txtAmount";
			this.txtAmount.Size = new System.Drawing.Size(96, 22);
			this.txtAmount.TabIndex = 0;
			this.txtAmount.Text = "";
			// 
			// lblAmount
			// 
			this.lblAmount.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblAmount.Location = new System.Drawing.Point(8, 88);
			this.lblAmount.Name = "lblAmount";
			this.lblAmount.Size = new System.Drawing.Size(100, 24);
			this.lblAmount.TabIndex = 2;
			this.lblAmount.Text = "Amount:";
			// 
			// btnPayIn
			// 
			this.btnPayIn.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnPayIn.Location = new System.Drawing.Point(8, 120);
			this.btnPayIn.Name = "btnPayIn";
			this.btnPayIn.Size = new System.Drawing.Size(120, 24);
			this.btnPayIn.TabIndex = 1;
			this.btnPayIn.Text = "Pay In";
			this.btnPayIn.Click += new System.EventHandler(this.btnPayIn_Click);
			// 
			// btnPayOut
			// 
			this.btnPayOut.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnPayOut.Location = new System.Drawing.Point(136, 120);
			this.btnPayOut.Name = "btnPayOut";
			this.btnPayOut.Size = new System.Drawing.Size(120, 24);
			this.btnPayOut.TabIndex = 1;
			this.btnPayOut.Text = "Pay Out";
			this.btnPayOut.Click += new System.EventHandler(this.btnPayOut_Click);
			// 
			// lblAccountBalance
			// 
			this.lblAccountBalance.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblAccountBalance.Location = new System.Drawing.Point(264, 11);
			this.lblAccountBalance.Name = "lblAccountBalance";
			this.lblAccountBalance.Size = new System.Drawing.Size(64, 24);
			this.lblAccountBalance.TabIndex = 2;
			this.lblAccountBalance.Text = "Balance:";
			// 
			// txtBalance
			// 
			this.txtBalance.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(192)), ((System.Byte)(255)));
			this.txtBalance.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtBalance.Location = new System.Drawing.Point(336, 8);
			this.txtBalance.Name = "txtBalance";
			this.txtBalance.ReadOnly = true;
			this.txtBalance.Size = new System.Drawing.Size(96, 22);
			this.txtBalance.TabIndex = 0;
			this.txtBalance.Text = "";
			// 
			// btnCheckBalance
			// 
			this.btnCheckBalance.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnCheckBalance.Location = new System.Drawing.Point(312, 40);
			this.btnCheckBalance.Name = "btnCheckBalance";
			this.btnCheckBalance.Size = new System.Drawing.Size(120, 24);
			this.btnCheckBalance.TabIndex = 1;
			this.btnCheckBalance.Text = "Check Balance";
			this.btnCheckBalance.Click += new System.EventHandler(this.btnCheckBalance_Click);
			// 
			// txtMessages
			// 
			this.txtMessages.AcceptsReturn = true;
			this.txtMessages.Location = new System.Drawing.Point(8, 184);
			this.txtMessages.Multiline = true;
			this.txtMessages.Name = "txtMessages";
			this.txtMessages.ReadOnly = true;
			this.txtMessages.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.txtMessages.Size = new System.Drawing.Size(440, 128);
			this.txtMessages.TabIndex = 3;
			this.txtMessages.Text = "";
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(8, 165);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(100, 24);
			this.label1.TabIndex = 2;
			this.label1.Text = "Messages:";
			// 
			// FormBankClient
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(456, 318);
			this.Controls.Add(this.txtMessages);
			this.Controls.Add(this.txtAccountNum);
			this.Controls.Add(this.lblAccountNum);
			this.Controls.Add(this.btnCreateAccount);
			this.Controls.Add(this.btnDeleteAccount);
			this.Controls.Add(this.txtAmount);
			this.Controls.Add(this.lblAmount);
			this.Controls.Add(this.btnPayIn);
			this.Controls.Add(this.btnPayOut);
			this.Controls.Add(this.lblAccountBalance);
			this.Controls.Add(this.txtBalance);
			this.Controls.Add(this.btnCheckBalance);
			this.Controls.Add(this.label1);
			this.Name = "FormBankClient";
			this.Text = "GUI Bank Client";
			this.Load += new System.EventHandler(this.FormBankClient_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FormBankClient());
		}

		private void FormBankClient_Load(object sender, System.EventArgs e)
		{
		
		}

		private void btnCheckBalance_Click(object sender, System.EventArgs e)
		{
			CheckBalance();
		}

		private void CheckBalance()
		{
			try 
			{
				txtBalance.Text = "" + objBank.checkAccountBalance(txtAccountNum.Text);
			} 
			catch (BankOperationException e)
			{
				PrintException(e);
			} 
			catch (Exception e)
			{
				PrintException(e);
			}
		}

		private void BankOperation(enumBankOperation eOperation)
		{
			try 
			{
				switch (eOperation)
				{
					case enumBankOperation.CreateAccount:
						objBank.createAccount(txtAccountNum.Text);
						CheckBalance();
						break;
					case enumBankOperation.DeleteAccount:
						objBank.deleteAccount(txtAccountNum.Text);
						break;
					case enumBankOperation.PayIn:
						objBank.payinAccount(txtAccountNum.Text, Convert.ToDouble(txtAmount.Text));
						CheckBalance();
						break;
					case enumBankOperation.PayOut:
						objBank.payoutAccount(txtAccountNum.Text, Convert.ToDouble(txtAmount.Text));
						CheckBalance();
						break;
				}
			} 
			catch (BankOperationException e)
			{
				PrintException(e);
			} 
			catch (Exception e)
			{
				PrintException(e);
			}
		}

		private void PrintException(BankOperationException e)
		{
			txtMessages.Text = "*** Bank Operation Error ***\r\n" + 
				"AccountNum: " + e.AccountNum + "\r\nOperation: " + e.Operation + 
				"\r\nMessage: " + e.Message + "\r\n\r\n" + txtMessages.Text;
		}

		private void btnPayOut_Click(object sender, System.EventArgs e)
		{
			BankOperation(enumBankOperation.PayOut);
		}

		private void btnPayIn_Click(object sender, System.EventArgs e)
		{
			BankOperation(enumBankOperation.PayIn);
		}

		private void btnDeleteAccount_Click(object sender, System.EventArgs e)
		{
			BankOperation(enumBankOperation.DeleteAccount);
		}

		private void btnCreateAccount_Click(object sender, System.EventArgs e)
		{
			BankOperation(enumBankOperation.CreateAccount);
		}

		private void PrintException(Exception e)
		{
			txtMessages.Text = "*** Program Error ***\r\nMessage: " + 
				e.Message + "\r\nStackTrace: " + e.StackTrace + "\r\n" + txtMessages.Text;
		}
	}
}
